/*
 * Created By Drake Vidkjer
 * Created on 10-20-17
 * Modified on 10-22-17
 * This program interprets different bit patterns as different variables
 */
 
#define F64_EXP_MASK 0x7FF
#define F64_EXP_SHIFT 52
#define F64_MANT_MASK 0xFFFFFFFFFFFFF
#define F64_MANT_SHIFT 0

#include <math.h>
#include <stdio.h>
#include <string.h>

//this union lets these different variables all point to the same memory space
union Bits
{
	double bitPattern;
	long integer;
	char characters[8];
};

int main(int argc, char **argv)
{
	//initialze variables
	int man, sign, exp;
	long val;
	
	//create a union between the different types
	union Bits pattern;
	
	//set some bit patters. Must be hardcoded in
	//pattern.bitPattern = -13.75;
	//pattern.bitPattern = 0b00110011101011001;
	strncpy(pattern.characters, "abcdefgh", 8);
	
	//extract the stuff for a double (sign, exp, man) and print them
	sign = (pattern.integer >> 63) & 1;
	exp = (pattern.integer >> F64_EXP_SHIFT) & F64_EXP_MASK;
	exp -= 1023;
	man = (pattern.integer & F64_MANT_MASK);
	printf("Bit pattern value as double: %lf\n", pattern.bitPattern);
	printf("Double interpretation of bit pattern: Sign = %d, Exp = %d, Mantissa = %d\n", sign, exp, man);
	
	//extract stuff from long and print it
	sign = (pattern.integer >> 63) & 1;
	//invert the bits to get the value of the long without a sign
	val = ~(pattern.integer);
	printf("Bit pattern value as long: %ld\n", pattern.integer);
	printf("Long interpretation of bit pattern: Sign = %d, Value = %ld\n", sign, val);	//need to fix this long problem
	
	//print as character array
	printf("8 character representation of the data: ");
	for(int i = 0; i < 8; i++)
	{
		printf("%c", pattern.characters[i]);
	}
	printf("\n");
	
	return 0;
}
