/*
 * Created By Drake Vidkjer
 * Created on 10-19-17
 * Modified on 10-24-17
 * Software implementation of floating point arithmetic
 */

#include <math.h>
#include <stdio.h>
#include <string.h>
#include <time.h>  
#include "fpu.h"

//function prototypes
void frexpTest();
double addTest();

int main(int argc, char **argv)
{
	//print out some information about the program
	printf("*******************************************************\n");
	printf("ECE 472 HW2, FPU Operations\nCreated by Drake Vidkjer on");
	printf(" 10-19-17\nModified on 10-24-17");
	printf("\n*****************************************************\n");
	
	clock_t fpuClock, softClock;
	
	//initialize local variables
	double time;
	volatile long j = 0;
	volatile double a, b, c;
	
	b = 4096.54;
	c = 20099.55666;
	
	//call the frexp implimentation
	frexpTest();
	
	//call the addition test
	time = addTest();
	
	printf("\n%lf and %lf will be added together\n", b, c);
	
	//actually do the testing and large loops
	fpuClock = clock();
	for(j = 0; j < 100000; j++)
	{
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
	}
	fpuClock = clock() - fpuClock;
	
	softClock = clock();
	for(j = 0; j < 100000; j++)
	{
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
		a = b + c;
	}
	softClock = clock() - softClock;
	
	fpuClock = (fpuClock - softClock)/20;
	
	printf("It takes %f seconds to complete the operation with the FPU\n", ((float)fpuClock)/CLOCKS_PER_SEC);
	
	//now do it for the software implimentation
	fpuClock = clock();
	for(j = 0; j < 100000; j++)
	{
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
	}
	fpuClock = clock() - fpuClock;
	
	softClock = clock();
	for(j = 0; j < 100000; j++)
	{
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
		a = add(b, c);
	}
	softClock = clock() - softClock;
	
	fpuClock = (fpuClock - softClock)/20;
	
	printf("It takes %f seconds to complete the operation with the software implimentation\n", ((float)fpuClock)/CLOCKS_PER_SEC);
	
	return 0;
}

void frexpTest()
{
	//define variables
	int n;
	double arg, number;
	
	//***this is the hardcoded value for my implimentatoin of frexp
	number = -54.25;
	
	//do it the frexp way
	arg = frexp(number, &n);
	printf ("%f = %f * 2^%d\n", number, arg, n);
	
	//do it our way
	arg = normalize(number, &n);
	printf ("%f = %f * 2^%d\n", number, arg, n);
}

double addTest()
{
	double a, b, c;
	printf("Addition test:\n");
	
	a = 7.35;
	b = 13.5;
	c = -1;
	
	c = add(a, b);
	printf("%lf + %lf = %lf\n", a, b, c);
	return -1;
}
